//
// Created by trokay on 18.06.23.
//

#ifndef MC_02_UART_MC0203_PROTOCOL_H
#define MC_02_UART_MC0203_PROTOCOL_H

#include <stdint.h>

#define COMMAND_SET_CONFIG_RESPONSE 0x81
#define COMMAND_GET_CONFIG_RESPONSE 0x80

#define COMMAND_SET_CONFIG 0x01
#define COMMAND_GET_CONFIG 0x00

#define DELIMITER_FLAG 0x7e

union ip_t {
    int addr;
    unsigned char addr_bytes[4];
};

/* Включить выравнивание структуры в памяти по границе 1 байта */
#pragma pack(push, 1)
struct config_t {
  uint8_t dhcp;
  uint32_t ip;
  uint32_t netmask;
  uint32_t gw;
  uint32_t dns;
};
#pragma pack(pop)

void decode_message(char *data, int size, int *new_size);

char calc_checksum(const char *data, int size);

void encode_message(char *data, int size, int *new_size);

int extract_data_from_command(char *source, int src_size,char *dest, int *dst_size);

void convert_from_string(char *response,
                         uint8_t *dhcp,
                         uint32_t *ip,
                         uint32_t *netmask,
                         uint32_t *gw,
                         uint32_t *dns);

void convert_to_string(char *response, struct config_t *config);

void get_response(char response[256],
                  int *response_size,
                  char *data,
                  int data_size,
                  uint8_t resp_code,
                  uint8_t index);

#endif //MC_02_UART_MC0203_PROTOCOL_H
