#ifndef _UTILS_H
#define _UTILS_H

#include <stdint.h>
#include <stdbool.h>
//#include <string>

int get_iface_mac(const char *ifname, uint8_t *mac);
int get_iface_ip(const char *ifname, uint32_t *ip);
int set_iface_ip(const char *ifname, uint32_t ip);
int get_iface_peer(const char *ifname, uint32_t *ip);
int get_iface_mask(const char *ifname, uint32_t *msk);
int set_iface_mask(const char *ifname, uint32_t msk);
int set_iface_ip6(const char *ifname, void *ip, int prefixlen);
int drop_iface_ip6(const char *ifname, bool including_link_local);
int iface_up(const char *ifname);
int get_default_gw(uint32_t *res);
int set_default_gw(uint32_t ip);
int get_route(uint32_t ip, uint32_t * res, char * ifname);
//int get_route(const struct in6_addr * ip, struct in6_addr * res, char * ifname, struct in6_addr * localaddr); // IPv6 version
int getMac(const char *dev, uint32_t ip, unsigned char *mac);
bool have_global_ip6(const char *ifname);
bool guess_ip6(struct in6_addr * ip, const char *ifname, int * prefix_len);
bool get_link_local_ip6(struct in6_addr * ip, const char *ifname, int * prefix_len);
int get_local_ipv6(const struct in6_addr * dst, struct in6_addr * res, char * ifname);
int get_neighbor_mac(const struct in6_addr * ip, uint8_t * mac);

#endif
